# coding: utf-8
import sys
from tkinter import *
from imagecanvas import *
leftPos   = [0,0,0]     #　左マウス座標位置と長方形の識別番号

#■左ボタンイベント処理
def leftMouseDown(event):#ダウン
    canvas.focus_set()
    x=event.x
    y=event.y
    leftPos[0]=x
    leftPos[1]=y
    leftPos[2]=canvas.create_rectangle(x,y,x,y,outline='blue')
    
def leftMouseMove(event):#マウス移動(長方形の座標を変更する)
    canvas.coords(leftPos[2],leftPos[0], leftPos[1], event.x, event.y)
    
def leftMouseRelease(event):#アップ(長方形を消して左上、右下の座標設定）
    canvas.delete(leftPos[2])
    xed=event.x
    yed=event.y
    xst=leftPos[0]
    yst=leftPos[1]
    if xst>xed:        # xst:左, xed: 右
        xst=xed
        xed=leftPos[0]
    if yst>yed:        # yst:上，yed: 下
        yst=xed
        yed=leftPos[1]
    drawMosaic(xst,xed,yst,yed)   #モザイク処理呼出し
    
#■モザイク処理    
def drawMosaic(xst, xed, yst,yed):
    NX=int((xed-xst)/16)
    NY=int((yed-yst)/16)
    x=xst
    for k1 in range(NX):      # X方向16個単位の繰返し
        y=yst
        for k2 in range(NY):  # Y方向16個単位の繰返し
            R=0
            G=0
            B=0
            for i in range(16): # R/G/B別に平均値を計算
                xx = x + i
                for j in range(16):
                    yy= y + j
                    R +=tmp[xx][yy][0]
                    G +=tmp[xx][yy][1]
                    B +=tmp[xx][yy][2]
            C=RGB(int(R/256),int(G/256),int(B/256))
            for i in range(16):
                xx = x + i
                for j in range(16):
                    yy= y + j
                    cbit.Canvas.itemconfig(cbit.ID[xx][yy],fill=C)
            y+=16
        x+=16
    root.update()
            
#■ウィンドウが閉じられるときの処理
def exitProc():
    if messagebox.askokcancel("終了","終了してもよろしいですか?"):
        root.destroy()
        sys.exit()

#■メイン処理   
root = Tk()
root.geometry("600x500")
root.title("モザイク処理")
FT=[('BMPファイルlファイル','*.bmp;*.*')]
filename=filedialog.askopenfilename(filetypes=FT)
if filename!="":
    root.title("ビットマップ読込み中")
    bitmap=readBitmap(filename)
    if bitmap!=[]:
        #準備処理
        root.title("キャンバス準備中")
        canvas=Canvas(root,width=bitmap.info.width,height=bitmap.info.height)
        canvas.place(x=0,y=30)
        canvas2=Canvas(root,width=bitmap.info.width,height=bitmap.info.height)
        canvas2.place(x=bitmap.info.width,y=30)
        canvas3=Canvas(root,width=110,height=110)
        canvas3.place(x=320,y=380)
        
        root.title("ビットマップ表示中")
        cbit=drawBitmap(canvas, bitmap)
        root.update()
        root.title("元画像ビットマップ表示中")
        c2=drawBitmap(canvas2, bitmap)
        root.update()
        
        root.title("ビットマップリスト準備中")
        tmp=getRGBList(cbit)
        root.title("モザイク処理")
        #左ボタン
        canvas.bind("<Button-1>",leftMouseDown)
        canvas.bind("<B1-Motion>",leftMouseMove)
        canvas.bind("<ButtonRelease-1>",leftMouseRelease)
       
        #ラベルの宣言
        label1 = Label(root, text='モザイクをかける範囲を左ボタンで指定します。', fg='black')
        label1.place(x=10, y=2)
        label2 = Label(root, text='元画像', fg='black')
        label2.place(x=bitmap.info.width+10, y=2)
       
        #ボタンの宣言                        
        button1 = Button(root, text='終了', command=exitProc)
        button1.place(x=500, y=400)
        
        #メインループ("WM_DELETE_WINDOW"が届いたときexitProcを呼び出す)
        root.protocol("WM_DELETE_WINDOW",exitProc)
        root.mainloop()
root.destroy()
sys.exit()
        
